(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@alyle/ui')) :
    typeof define === 'function' && define.amd ? define('@alyle/ui/skeleton', ['exports', '@angular/core', '@alyle/ui'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.ly = global.ly || {}, global.ly.skeleton = {}), global.ng.core, global.ly.core));
}(this, (function (exports, core, ui) { 'use strict';

    var STYLE_PRIORITY = -0.5;
    var STYLES = function (theme) {
        var id = ui.keyframesUniqueId.next();
        var _a = theme.background, primary = _a.primary, secondary = _a.secondary, tertiary = _a.tertiary;
        var dir = theme.direction === ui.Dir.ltr ? -1 : 1;
        var lum = primary.default.luminance();
        var one = (lum < .5
            ? tertiary
            : secondary);
        var two = (lum < .5
            ? secondary
            : tertiary);
        one = one.darken(1 * (lum < .5 ? -.5 : 0));
        two = two.darken(.25 * (lum < .5 ? -1 : 1));
        return {
            $name: LySkeleton.и,
            $priority: STYLE_PRIORITY,
            $global: function (className) { return "@keyframes " + id + "{" + className + " 0%{background-position:" + -dir * 200 + "% 50%;}" + className + " 100%{background-position:" + dir * 200 + "% 50%;}}"; },
            root: function (className) { return className + "{content:'';background:" + ("linear-gradient(270deg, " + one + ", " + two + ", " + two + ", " + one + ")") + ";background-size:400% 400%;animation:" + id + " 8s ease-in-out infinite;color:transparent;cursor:progress;user-select:none;}"; }
        };
    };
    var LySkeleton = /** @class */ (function () {
        function LySkeleton(sRenderer) {
            this.sRenderer = sRenderer;
            /** @docs-private */
            this.classes = this.sRenderer.renderSheet(STYLES);
        }
        Object.defineProperty(LySkeleton.prototype, "skeleton", {
            get: function () {
                return this._skeleton;
            },
            set: function (val) {
                var newVal = ui.toBoolean(val);
                this._skeleton = newVal;
                this.sRenderer.toggleClass(this.classes.root, newVal);
            },
            enumerable: false,
            configurable: true
        });
        return LySkeleton;
    }());
    /** @docs-private */
    LySkeleton.и = 'LySkeleton';
    LySkeleton.decorators = [
        { type: core.Directive, args: [{
                    selector: '[lySkeleton]',
                    providers: [
                        ui.StyleRenderer
                    ],
                    exportAs: 'lySkeleton'
                },] }
    ];
    LySkeleton.ctorParameters = function () { return [
        { type: ui.StyleRenderer }
    ]; };
    LySkeleton.propDecorators = {
        skeleton: [{ type: core.Input, args: ['lySkeleton',] }]
    };

    var LySkeletonModule = /** @class */ (function () {
        function LySkeletonModule() {
        }
        return LySkeletonModule;
    }());
    LySkeletonModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [LySkeleton],
                    exports: [LySkeleton]
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.LySkeleton = LySkeleton;
    exports.LySkeletonModule = LySkeletonModule;
    exports.STYLES = STYLES;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=alyle-ui-skeleton.umd.js.map
